/* math-converter.c generated by valac 0.56.18, the Vala compiler
 * generated from math-converter.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "calculator.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <langinfo.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
typedef struct _MathConverterPrivate MathConverterPrivate;
enum  {
	MATH_CONVERTER_0_PROPERTY,
	MATH_CONVERTER_EQUATION_PROPERTY,
	MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY,
	MATH_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* math_converter_properties[MATH_CONVERTER_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_expression_unref0(var) ((var == NULL) ? NULL : (var = (gtk_expression_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
#define _gdk_event_unref0(var) ((var == NULL) ? NULL : (var = (gdk_event_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL,
	MATH_CONVERTER_NUM_SIGNALS
};
static guint math_converter_signals[MATH_CONVERTER_NUM_SIGNALS] = {0};

struct _MathConverter {
	GtkGrid parent_instance;
	MathConverterPrivate * priv;
};

struct _MathConverterClass {
	GtkGridClass parent_class;
};

struct _MathConverterPrivate {
	MathEquation* _equation;
	gchar* category;
	Number* from_number;
	Number* to_number;
	GtkDropDown* category_combo;
	GtkDropDown* from_combo;
	GtkDropDown* to_combo;
	GtkTextView* from_entry;
	GtkTextView* to_entry;
	GtkPopoverMenu* from_context_menu;
	GtkPopoverMenu* to_context_menu;
	Serializer* fixed_serializer;
	GtkEventControllerKey* from_event_controller;
	GtkEventControllerKey* to_event_controller;
	gulong from_combobox_changed;
	gulong from_entry_changed;
	gulong to_entry_changed;
	GSimpleActionGroup* action_group;
	gboolean _outer_box_visible;
};

struct _Block3Data {
	int _ref_count_;
	MathConverter* self;
	GdkClipboard* clipboard;
};

static gint MathConverter_private_offset;
static gpointer math_converter_parent_class = NULL;

VALA_EXTERN GType math_converter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MathConverter, g_object_unref)
static void math_converter_popup_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void math_converter_copy_cb (MathConverter* self,
                             GSimpleAction* action,
                             GVariant* param);
static void _math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static void math_converter_paste_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
VALA_EXTERN MathConverter* math_converter_new (MathEquation* equation);
VALA_EXTERN MathConverter* math_converter_construct (GType object_type,
                                         MathEquation* equation);
static void math_converter_construct_finish (MathConverter* self);
VALA_EXTERN MathEquation* math_converter_get_equation (MathConverter* self);
static void __lambda12_ (MathConverter* self);
static void math_converter_update_visibility (MathConverter* self);
static void ___lambda12__currency_manager_updated (CurrencyManager* _sender,
                                            gpointer self);
static void math_converter_build_category_model (MathConverter* self);
static void math_converter_build_units_model (MathConverter* self);
static void math_converter_reformat_display (MathConverter* self);
static void _math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                     Serializer* serializer,
                                                                     gpointer self);
static void math_converter_from_combobox_changed_cb (MathConverter* self);
static void _math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void math_converter_from_entry_changed_cb (MathConverter* self);
static void _math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                    gpointer self);
static void math_converter_to_entry_changed_cb (MathConverter* self);
static void _math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                  gpointer self);
VALA_EXTERN void math_converter_set_conversion (MathConverter* self,
                                    const gchar* unit_a,
                                    const gchar* unit_b);
static gint ____lambda13_ (MathConverter* self,
                    GObject* c1,
                    GObject* c2);
static gint _____lambda13__gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
VALA_EXTERN gchar* math_converter_get_category (MathConverter* self);
static gboolean math_converter_set_active_unit (MathConverter* self,
                                         GtkDropDown* combo,
                                         Unit* unit);
static void math_converter_to_combobox_changed_cb (MathConverter* self);
VALA_EXTERN void math_converter_get_conversion (MathConverter* self,
                                    Unit** from_unit,
                                    Unit** to_unit);
VALA_EXTERN void math_converter_insert_text (MathConverter* self,
                                 const gchar* text);
VALA_EXTERN void math_converter_insert_numeric_point (MathConverter* self);
VALA_EXTERN void math_converter_clear (MathConverter* self);
VALA_EXTERN void math_converter_backspace (MathConverter* self);
VALA_EXTERN void math_converter_paste (MathConverter* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda11_ (Block3Data* _data3_,
                  GObject* obj,
                  GAsyncResult* res);
static void math_converter_on_paste (MathConverter* self,
                              const gchar* text);
static void ___lambda11__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN void math_converter_set_outer_box_visible (MathConverter* self,
                                           gboolean value);
static void math_converter_category_combobox_changed_cb (MathConverter* self);
static void _math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static Number* math_converter_convert_equation (MathConverter* self,
                                         Number* x,
                                         Unit** source_unit,
                                         Unit** target_unit);
static void math_converter_save_selected_units (MathConverter* self);
static void _math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void math_converter_from_entry_focus_cb (MathConverter* self);
static Number* math_converter_get_number_from_string (MathConverter* self,
                                               const gchar* str);
static void _math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void math_converter_to_entry_focus_cb (MathConverter* self);
static void _math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static gboolean math_converter_key_press_cb (MathConverter* self,
                                      GtkEventControllerKey* controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType mod_state);
static gboolean _math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self);
static void math_converter_from_entry_click_cb (MathConverter* self,
                                         GtkGestureClick* gesture,
                                         gint n_click,
                                         gdouble x,
                                         gdouble y);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static void math_converter_show_context_menu (MathConverter* self,
                                       GtkTextView* entry,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void math_converter_to_entry_click_cb (MathConverter* self,
                                       GtkGestureClick* gesture,
                                       gint n_click,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self);
VALA_EXTERN void math_converter_swap_units (MathConverter* self);
VALA_EXTERN void math_converter_set_equation (MathConverter* self,
                                  MathEquation* value);
VALA_EXTERN gboolean math_converter_get_outer_box_visible (MathConverter* self);
static GObject * math_converter_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void math_converter_finalize (GObject * obj);
static GType math_converter_get_type_once (void);
static void _vala_math_converter_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_math_converter_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry MATH_CONVERTER_action_entries[3] = {{"popup", _math_converter_popup_cb_gsimple_action_activate_callback}, {"copy", _math_converter_copy_cb_gsimple_action_activate_callback}, {"paste", _math_converter_paste_cb_gsimple_action_activate_callback}};

static inline gpointer
math_converter_get_instance_private (MathConverter* self)
{
	return G_STRUCT_MEMBER_P (self, MathConverter_private_offset);
}

static void
_math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
	math_converter_popup_cb ((MathConverter*) self, action, parameter);
}

static void
_math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
	math_converter_copy_cb ((MathConverter*) self, action, parameter);
}

static void
_math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
	math_converter_paste_cb ((MathConverter*) self, action, parameter);
}

MathConverter*
math_converter_construct (GType object_type,
                          MathEquation* equation)
{
	MathConverter * self = NULL;
	g_return_val_if_fail (equation != NULL, NULL);
	self = (MathConverter*) g_object_new (object_type, "equation", equation, NULL);
	return self;
}

MathConverter*
math_converter_new (MathEquation* equation)
{
	return math_converter_construct (TYPE_MATH_CONVERTER, equation);
}

static void
__lambda12_ (MathConverter* self)
{
	math_converter_update_visibility (self);
}

static void
___lambda12__currency_manager_updated (CurrencyManager* _sender,
                                       gpointer self)
{
	__lambda12_ ((MathConverter*) self);
}

static void
_math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                Serializer* serializer,
                                                                gpointer self)
{
	math_converter_reformat_display ((MathConverter*) self);
}

static void
_math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
	math_converter_from_combobox_changed_cb ((MathConverter*) self);
}

static void
_math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                               gpointer self)
{
	math_converter_from_entry_changed_cb ((MathConverter*) self);
}

static void
_math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                             gpointer self)
{
	math_converter_to_entry_changed_cb ((MathConverter*) self);
}

static void
math_converter_construct_finish (MathConverter* self)
{
	MathEquation* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	MathEquation* _tmp3_;
	GtkDropDown* _tmp4_;
	gulong _tmp5_;
	MathEquation* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	Serializer* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	GtkTextView* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextBuffer* _tmp14_;
	MathEquation* _tmp15_;
	Serializer* _tmp16_;
	Serializer* _tmp17_;
	Number* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkTextView* _tmp21_;
	GtkTextBuffer* _tmp22_;
	GtkTextBuffer* _tmp23_;
	MathEquation* _tmp24_;
	Serializer* _tmp25_;
	Serializer* _tmp26_;
	Number* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GtkTextView* _tmp30_;
	GtkTextBuffer* _tmp31_;
	GtkTextBuffer* _tmp32_;
	gulong _tmp33_;
	GtkTextView* _tmp34_;
	GtkTextBuffer* _tmp35_;
	GtkTextBuffer* _tmp36_;
	gulong _tmp37_;
	MathEquation* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	MathEquation* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_equation;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
	_tmp2_ = _tmp1_;
	g_signal_connect_object (_tmp2_, "updated", (GCallback) ___lambda12__currency_manager_updated, self, 0);
	_g_object_unref0 (_tmp2_);
	math_converter_build_category_model (self);
	math_converter_update_visibility (self);
	math_converter_build_units_model (self);
	_tmp3_ = self->priv->_equation;
	g_signal_connect_object (_tmp3_, "display-changed", (GCallback) _math_converter_reformat_display_math_equation_display_changed, self, 0);
	_tmp4_ = self->priv->from_combo;
	_tmp5_ = g_signal_connect_object ((GObject*) _tmp4_, "notify::selected", (GCallback) _math_converter_from_combobox_changed_cb_g_object_notify, self, 0);
	self->priv->from_combobox_changed = _tmp5_;
	_tmp6_ = self->priv->_equation;
	_tmp7_ = math_equation_get_accuracy (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = serializer_new (DISPLAY_FORMAT_FIXED, 10, _tmp8_);
	_g_object_unref0 (self->priv->fixed_serializer);
	self->priv->fixed_serializer = _tmp9_;
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
	_g_object_unref0 (self->priv->from_number);
	self->priv->from_number = _tmp10_;
	_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
	_g_object_unref0 (self->priv->to_number);
	self->priv->to_number = _tmp11_;
	_tmp12_ = self->priv->from_entry;
	_tmp13_ = gtk_text_view_get_buffer (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->_equation;
	_tmp16_ = math_equation_get_serializer (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->from_number;
	_tmp19_ = serializer_to_string (_tmp17_, _tmp18_);
	_tmp20_ = _tmp19_;
	g_object_set (_tmp14_, "text", _tmp20_, NULL);
	_g_free0 (_tmp20_);
	_tmp21_ = self->priv->to_entry;
	_tmp22_ = gtk_text_view_get_buffer (_tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = self->priv->_equation;
	_tmp25_ = math_equation_get_serializer (_tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = self->priv->to_number;
	_tmp28_ = serializer_to_string (_tmp26_, _tmp27_);
	_tmp29_ = _tmp28_;
	g_object_set (_tmp23_, "text", _tmp29_, NULL);
	_g_free0 (_tmp29_);
	_tmp30_ = self->priv->from_entry;
	_tmp31_ = gtk_text_view_get_buffer (_tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = g_signal_connect_object (_tmp32_, "changed", (GCallback) _math_converter_from_entry_changed_cb_gtk_text_buffer_changed, self, 0);
	self->priv->from_entry_changed = _tmp33_;
	_tmp34_ = self->priv->to_entry;
	_tmp35_ = gtk_text_view_get_buffer (_tmp34_);
	_tmp36_ = _tmp35_;
	_tmp37_ = g_signal_connect_object (_tmp36_, "changed", (GCallback) _math_converter_to_entry_changed_cb_gtk_text_buffer_changed, self, 0);
	self->priv->to_entry_changed = _tmp37_;
	_tmp38_ = self->priv->_equation;
	_tmp39_ = math_equation_get_source_units (_tmp38_);
	_tmp40_ = _tmp39_;
	_tmp41_ = _tmp40_;
	_tmp42_ = self->priv->_equation;
	_tmp43_ = math_equation_get_target_units (_tmp42_);
	_tmp44_ = _tmp43_;
	_tmp45_ = _tmp44_;
	math_converter_set_conversion (self, _tmp41_, _tmp45_);
	_g_free0 (_tmp45_);
	_g_free0 (_tmp41_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gint
____lambda13_ (MathConverter* self,
               GObject* c1,
               GObject* c2)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint result;
	g_return_val_if_fail (c1 != NULL, 0);
	g_return_val_if_fail (c2 != NULL, 0);
	_tmp0_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c1, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c1) : NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c2, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c2) : NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp6_ = g_utf8_collate (_tmp2_, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
	result = _tmp6_;
	return result;
}

static gint
_____lambda13__gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = ____lambda13_ ((MathConverter*) self, (GObject*) a, (GObject*) b);
	return result;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
math_converter_build_category_model (MathConverter* self)
{
	GListStore* category_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GList* categories = NULL;
	UnitManager* _tmp2_;
	UnitManager* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GtkDropDown* _tmp10_;
	GtkPropertyExpression* _tmp11_;
	GtkDropDown* _tmp12_;
	GListStore* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_list_store_new (TYPE_UNIT_CATEGORY);
	category_model = _tmp0_;
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT_CATEGORY, NULL, "display_name");
	expression = _tmp1_;
	_tmp2_ = unit_manager_get_default ();
	_tmp3_ = _tmp2_;
	_tmp4_ = unit_manager_get_categories (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp3_);
	categories = _tmp5_;
	_tmp6_ = categories;
	{
		GList* category_collection = NULL;
		GList* category_it = NULL;
		category_collection = _tmp6_;
		for (category_it = category_collection; category_it != NULL; category_it = category_it->next) {
			UnitCategory* _tmp7_;
			UnitCategory* category = NULL;
			_tmp7_ = _g_object_ref0 ((UnitCategory*) category_it->data);
			category = _tmp7_;
			{
				GListStore* _tmp8_;
				UnitCategory* _tmp9_;
				_tmp8_ = category_model;
				_tmp9_ = category;
				g_list_store_insert_sorted (_tmp8_, (GObject*) _tmp9_, _____lambda13__gcompare_data_func, self);
				_g_object_unref0 (category);
			}
		}
	}
	_tmp10_ = self->priv->category_combo;
	_tmp11_ = expression;
	gtk_drop_down_set_expression (_tmp10_, (GtkExpression*) _tmp11_);
	_tmp12_ = self->priv->category_combo;
	_tmp13_ = category_model;
	gtk_drop_down_set_model (_tmp12_, (GListModel*) _tmp13_);
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
	_gtk_expression_unref0 (expression);
	_g_object_unref0 (category_model);
}

void
math_converter_set_category (MathConverter* self,
                             const gchar* category)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->category;
	if (g_strcmp0 (_tmp0_, category) == 0) {
		return;
	}
	_tmp1_ = g_strdup (category);
	_g_free0 (self->priv->category);
	self->priv->category = _tmp1_;
	_tmp2_ = self->priv->category;
	if (_tmp2_ != NULL) {
		UnitCategory* unit_category = NULL;
		UnitManager* _tmp3_;
		UnitManager* _tmp4_;
		const gchar* _tmp5_;
		UnitCategory* _tmp6_;
		UnitCategory* _tmp7_;
		guint position = 0U;
		GListStore* model = NULL;
		GtkDropDown* _tmp8_;
		GListModel* _tmp9_;
		GListStore* _tmp10_;
		GListStore* _tmp11_;
		UnitCategory* _tmp12_;
		guint _tmp13_ = 0U;
		GtkDropDown* _tmp14_;
		_tmp3_ = unit_manager_get_default ();
		_tmp4_ = _tmp3_;
		_tmp5_ = self->priv->category;
		_tmp6_ = unit_manager_get_category (_tmp4_, _tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp4_);
		unit_category = _tmp7_;
		position = (guint) 0;
		_tmp8_ = self->priv->category_combo;
		_tmp9_ = gtk_drop_down_get_model (_tmp8_);
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, g_list_store_get_type ()) ? ((GListStore*) _tmp9_) : NULL);
		model = _tmp10_;
		_tmp11_ = model;
		_tmp12_ = unit_category;
		g_list_store_find (_tmp11_, (GObject*) _tmp12_, &_tmp13_);
		position = _tmp13_;
		_tmp14_ = self->priv->category_combo;
		gtk_drop_down_set_selected (_tmp14_, position);
		_g_object_unref0 (model);
		_g_object_unref0 (unit_category);
	} else {
		GtkDropDown* _tmp15_;
		_tmp15_ = self->priv->category_combo;
		gtk_drop_down_set_selected (_tmp15_, (guint) 0);
	}
}

gchar*
math_converter_get_category (MathConverter* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->category;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}

void
math_converter_set_conversion (MathConverter* self,
                               const gchar* unit_a,
                               const gchar* unit_b)
{
	Unit* ua = NULL;
	UnitManager* _tmp0_;
	UnitManager* _tmp1_;
	Unit* _tmp2_;
	Unit* _tmp3_;
	Unit* ub = NULL;
	UnitManager* _tmp4_;
	UnitManager* _tmp5_;
	Unit* _tmp6_;
	Unit* _tmp7_;
	UnitCategory* uc = NULL;
	UnitManager* _tmp8_;
	UnitManager* _tmp9_;
	UnitCategory* _tmp10_;
	UnitCategory* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	Unit* _tmp14_;
	UnitCategory* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkDropDown* _tmp22_;
	GtkDropDown* _tmp23_;
	Unit* _tmp24_;
	GtkDropDown* _tmp25_;
	GtkDropDown* _tmp26_;
	Unit* _tmp27_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (unit_a != NULL);
	g_return_if_fail (unit_b != NULL);
	_tmp0_ = unit_manager_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = unit_manager_get_unit_by_name (_tmp1_, unit_a);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	ua = _tmp3_;
	_tmp4_ = unit_manager_get_default ();
	_tmp5_ = _tmp4_;
	_tmp6_ = unit_manager_get_unit_by_name (_tmp5_, unit_b);
	_tmp7_ = _tmp6_;
	_g_object_unref0 (_tmp5_);
	ub = _tmp7_;
	_tmp8_ = unit_manager_get_default ();
	_tmp9_ = _tmp8_;
	_tmp10_ = unit_manager_get_category_of_unit (_tmp9_, unit_a);
	_tmp11_ = _tmp10_;
	_g_object_unref0 (_tmp9_);
	uc = _tmp11_;
	_tmp14_ = ua;
	if (_tmp14_ == NULL) {
		_tmp13_ = TRUE;
	} else {
		Unit* _tmp15_;
		_tmp15_ = ub;
		_tmp13_ = _tmp15_ == NULL;
	}
	if (_tmp13_) {
		_tmp12_ = TRUE;
	} else {
		UnitCategory* _tmp16_;
		_tmp16_ = uc;
		_tmp12_ = _tmp16_ == NULL;
	}
	if (_tmp12_) {
		GtkDropDown* _tmp17_;
		_tmp17_ = self->priv->from_combo;
		gtk_drop_down_set_selected (_tmp17_, (guint) 0);
		_g_object_unref0 (uc);
		_g_object_unref0 (ub);
		_g_object_unref0 (ua);
		return;
	}
	_tmp18_ = uc;
	_tmp19_ = unit_category_get_name (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_;
	math_converter_set_category (self, _tmp21_);
	_g_free0 (_tmp21_);
	_tmp22_ = self->priv->from_combo;
	g_signal_handler_block (_tmp22_, self->priv->from_combobox_changed);
	_tmp23_ = self->priv->from_combo;
	_tmp24_ = ua;
	math_converter_set_active_unit (self, _tmp23_, _tmp24_);
	_tmp25_ = self->priv->from_combo;
	g_signal_handler_unblock (_tmp25_, self->priv->from_combobox_changed);
	_tmp26_ = self->priv->to_combo;
	_tmp27_ = ub;
	math_converter_set_active_unit (self, _tmp26_, _tmp27_);
	math_converter_to_combobox_changed_cb (self);
	_g_object_unref0 (uc);
	_g_object_unref0 (ub);
	_g_object_unref0 (ua);
}

void
math_converter_get_conversion (MathConverter* self,
                               Unit** from_unit,
                               Unit** to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	Unit* _tmp3_;
	GtkDropDown* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	Unit* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->from_combo;
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT) ? ((Unit*) _tmp2_) : NULL);
	_g_object_unref0 (_vala_from_unit);
	_vala_from_unit = _tmp3_;
	_tmp4_ = self->priv->to_combo;
	_tmp5_ = gtk_drop_down_get_selected_item (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_UNIT) ? ((Unit*) _tmp6_) : NULL);
	_g_object_unref0 (_vala_to_unit);
	_vala_to_unit = _tmp7_;
	if (from_unit) {
		*from_unit = _vala_from_unit;
	} else {
		_g_object_unref0 (_vala_from_unit);
	}
	if (to_unit) {
		*to_unit = _vala_to_unit;
	} else {
		_g_object_unref0 (_vala_to_unit);
	}
}

void
math_converter_insert_text (MathConverter* self,
                            const gchar* text)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gboolean _tmp16_;
	GtkTextView* _tmp28_;
	GtkTextBuffer* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextView* _tmp31_;
	GtkTextBuffer* _tmp32_;
	GtkTextBuffer* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp1_ = self->priv->to_entry;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkTextView* _tmp4_;
		_tmp4_ = self->priv->to_entry;
		_tmp0_ = _tmp4_;
	} else {
		GtkTextView* _tmp5_;
		_tmp5_ = self->priv->from_entry;
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp0_);
	entry = _tmp6_;
	_tmp7_ = entry;
	_tmp8_ = self->priv->from_entry;
	if (_tmp7_ == _tmp8_) {
		GtkTextView* _tmp9_;
		_tmp9_ = self->priv->from_entry;
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
	}
	_tmp10_ = entry;
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
	_tmp12_ = _tmp11_;
	g_object_get (_tmp12_, "text", &_tmp13_, NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strcmp0 (_tmp15_, "0") == 0;
	_g_free0 (_tmp15_);
	if (_tmp16_) {
		GtkTextIter iter = {0};
		GtkTextView* _tmp17_;
		GtkTextBuffer* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextView* _tmp20_;
		GtkTextBuffer* _tmp21_;
		GtkTextBuffer* _tmp22_;
		GtkTextMark* _tmp23_;
		GtkTextIter _tmp24_ = {0};
		_tmp17_ = entry;
		_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = entry;
		_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = gtk_text_buffer_get_insert (_tmp22_);
		gtk_text_buffer_get_iter_at_mark (_tmp19_, &_tmp24_, _tmp23_);
		iter = _tmp24_;
		if (gtk_text_iter_is_end (&iter)) {
			GtkTextView* _tmp25_;
			GtkTextBuffer* _tmp26_;
			GtkTextBuffer* _tmp27_;
			_tmp25_ = entry;
			_tmp26_ = gtk_text_view_get_buffer (_tmp25_);
			_tmp27_ = _tmp26_;
			g_object_set (_tmp27_, "text", "", NULL);
		}
	}
	_tmp28_ = entry;
	_tmp29_ = gtk_text_view_get_buffer (_tmp28_);
	_tmp30_ = _tmp29_;
	gtk_text_buffer_delete_selection (_tmp30_, TRUE, TRUE);
	_tmp31_ = entry;
	_tmp32_ = gtk_text_view_get_buffer (_tmp31_);
	_tmp33_ = _tmp32_;
	_tmp34_ = strlen (text);
	_tmp35_ = _tmp34_;
	gtk_text_buffer_insert_at_cursor (_tmp33_, text, _tmp35_);
	_g_object_unref0 (entry);
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	g_unichar_to_utf8 (self, str);
	result = str;
	return result;
}

void
math_converter_insert_numeric_point (MathConverter* self)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	gchar* text = NULL;
	Serializer* _tmp10_;
	gchar* _tmp11_;
	GtkTextView* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextBuffer* _tmp14_;
	GtkTextView* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextBuffer* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->to_entry;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkTextView* _tmp4_;
		_tmp4_ = self->priv->to_entry;
		_tmp0_ = _tmp4_;
	} else {
		GtkTextView* _tmp5_;
		_tmp5_ = self->priv->from_entry;
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp0_);
	entry = _tmp6_;
	_tmp7_ = entry;
	_tmp8_ = self->priv->from_entry;
	if (_tmp7_ == _tmp8_) {
		GtkTextView* _tmp9_;
		_tmp9_ = self->priv->from_entry;
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
	}
	_tmp10_ = self->priv->fixed_serializer;
	_tmp11_ = g_unichar_to_string (serializer_get_radix (_tmp10_));
	text = _tmp11_;
	_tmp12_ = entry;
	_tmp13_ = gtk_text_view_get_buffer (_tmp12_);
	_tmp14_ = _tmp13_;
	gtk_text_buffer_delete_selection (_tmp14_, TRUE, TRUE);
	_tmp15_ = entry;
	_tmp16_ = gtk_text_view_get_buffer (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = strlen (text);
	_tmp19_ = _tmp18_;
	gtk_text_buffer_insert_at_cursor (_tmp17_, text, _tmp19_);
	_g_free0 (text);
	_g_object_unref0 (entry);
}

void
math_converter_clear (MathConverter* self)
{
	GtkTextView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->from_entry;
	g_object_get ((GtkWidget*) _tmp0_, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkTextView* _tmp3_;
		GtkTextBuffer* _tmp4_;
		GtkTextBuffer* _tmp5_;
		_tmp3_ = self->priv->from_entry;
		_tmp4_ = gtk_text_view_get_buffer (_tmp3_);
		_tmp5_ = _tmp4_;
		g_object_set (_tmp5_, "text", "0", NULL);
	} else {
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		MathEquation* _tmp9_;
		Serializer* _tmp10_;
		Serializer* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = self->priv->from_entry;
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = self->priv->_equation;
		_tmp10_ = math_equation_get_serializer (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = number_new_integer ((gint64) 0, (gint64) 0);
		_tmp13_ = _tmp12_;
		_tmp14_ = serializer_to_string (_tmp11_, _tmp13_);
		_tmp15_ = _tmp14_;
		g_object_set (_tmp8_, "text", _tmp15_, NULL);
		_g_free0 (_tmp15_);
		_g_object_unref0 (_tmp13_);
	}
}

void
math_converter_backspace (MathConverter* self)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->to_entry;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkTextView* _tmp4_;
		_tmp4_ = self->priv->to_entry;
		_tmp0_ = _tmp4_;
	} else {
		GtkTextView* _tmp5_;
		_tmp5_ = self->priv->from_entry;
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp0_);
	entry = _tmp6_;
	_tmp7_ = entry;
	_tmp8_ = self->priv->from_entry;
	if (_tmp7_ == _tmp8_) {
		GtkTextView* _tmp9_;
		_tmp9_ = self->priv->from_entry;
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
	}
	_tmp10_ = entry;
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = gtk_text_buffer_get_has_selection (_tmp12_);
	_tmp14_ = _tmp13_;
	if (_tmp14_) {
		GtkTextView* _tmp15_;
		GtkTextBuffer* _tmp16_;
		GtkTextBuffer* _tmp17_;
		_tmp15_ = entry;
		_tmp16_ = gtk_text_view_get_buffer (_tmp15_);
		_tmp17_ = _tmp16_;
		gtk_text_buffer_delete_selection (_tmp17_, TRUE, TRUE);
	} else {
		GtkTextIter iter = {0};
		GtkTextView* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextBuffer* _tmp20_;
		GtkTextView* _tmp21_;
		GtkTextBuffer* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextMark* _tmp24_;
		GtkTextIter _tmp25_ = {0};
		GtkTextView* _tmp26_;
		GtkTextBuffer* _tmp27_;
		GtkTextBuffer* _tmp28_;
		_tmp18_ = entry;
		_tmp19_ = gtk_text_view_get_buffer (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = entry;
		_tmp22_ = gtk_text_view_get_buffer (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = gtk_text_buffer_get_insert (_tmp23_);
		gtk_text_buffer_get_iter_at_mark (_tmp20_, &_tmp25_, _tmp24_);
		iter = _tmp25_;
		_tmp26_ = entry;
		_tmp27_ = gtk_text_view_get_buffer (_tmp26_);
		_tmp28_ = _tmp27_;
		gtk_text_buffer_backspace (_tmp28_, &iter, TRUE, TRUE);
	}
	_g_object_unref0 (entry);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		MathConverter* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->clipboard);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
__lambda11_ (Block3Data* _data3_,
             GObject* obj,
             GAsyncResult* res)
{
	MathConverter* self;
	GError* _inner_error0_ = NULL;
	self = _data3_->self;
	g_return_if_fail (res != NULL);
	{
		gchar* _tmp0_ = NULL;
		GdkClipboard* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = _data3_->clipboard;
		_tmp2_ = gdk_clipboard_read_text_finish (_tmp1_, res, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		math_converter_on_paste (self, _tmp0_);
		_g_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = err;
		_tmp4_ = _tmp3_->message;
		g_print ("%s", _tmp4_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda11__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda11_ (self, source_object, res);
	block3_data_unref (self);
}

void
math_converter_paste (MathConverter* self)
{
	Block3Data* _data3_;
	gboolean _tmp0_ = FALSE;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GdkDisplay* _tmp7_;
	GdkClipboard* _tmp8_;
	GdkClipboard* _tmp9_;
	GdkClipboard* _tmp10_;
	g_return_if_fail (self != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp1_ = self->priv->from_entry;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		GtkTextView* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->to_entry;
		g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
		_tmp6_ = _tmp5_;
		_tmp0_ = !_tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		block3_data_unref (_data3_);
		_data3_ = NULL;
		return;
	}
	_tmp7_ = gdk_display_get_default ();
	_tmp8_ = gdk_display_get_clipboard (_tmp7_);
	_tmp9_ = _g_object_ref0 (_tmp8_);
	_data3_->clipboard = _tmp9_;
	_tmp10_ = _data3_->clipboard;
	gdk_clipboard_read_text_async (_tmp10_, NULL, ___lambda11__gasync_ready_callback, block3_data_ref (_data3_));
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (delimiters != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strdelimit (_result_, delimiters, new_delimiter);
	result = _result_;
	return result;
}

static void
math_converter_on_paste (MathConverter* self,
                         const gchar* text)
{
	g_return_if_fail (self != NULL);
	if (text != NULL) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = string_delimit (text, "\n", ' ');
		_tmp1_ = _tmp0_;
		math_converter_insert_text (self, _tmp1_);
		_g_free0 (_tmp1_);
	}
}

static void
math_converter_update_visibility (MathConverter* self)
{
	const gchar* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->category;
	if (g_strcmp0 (_tmp0_, "currency") != 0) {
		math_converter_set_outer_box_visible (self, TRUE);
		return;
	}
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
	_tmp2_ = _tmp1_;
	_tmp3_ = currency_manager_get_loaded (_tmp2_);
	_tmp4_ = _tmp3_;
	math_converter_set_outer_box_visible (self, _tmp4_);
	_g_object_unref0 (_tmp2_);
}

static void
math_converter_build_units_model (MathConverter* self)
{
	GListStore* unit_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GtkDropDown* _tmp2_;
	GtkPropertyExpression* _tmp3_;
	GtkDropDown* _tmp4_;
	GtkPropertyExpression* _tmp5_;
	UnitCategory* c = NULL;
	UnitManager* _tmp6_;
	UnitManager* _tmp7_;
	const gchar* _tmp8_;
	UnitCategory* _tmp9_;
	UnitCategory* _tmp10_;
	UnitCategory* _tmp11_;
	GList* _tmp12_;
	guint model_size = 0U;
	GListStore* _tmp16_;
	GtkDropDown* _tmp17_;
	GListStore* _tmp18_;
	GtkDropDown* _tmp19_;
	GtkDropDown* _tmp20_;
	GListStore* _tmp21_;
	GtkDropDown* _tmp22_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_list_store_new (TYPE_UNIT);
	unit_model = _tmp0_;
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT, NULL, "display_name");
	expression = _tmp1_;
	_tmp2_ = self->priv->from_combo;
	_tmp3_ = expression;
	gtk_drop_down_set_expression (_tmp2_, (GtkExpression*) _tmp3_);
	_tmp4_ = self->priv->to_combo;
	_tmp5_ = expression;
	gtk_drop_down_set_expression (_tmp4_, (GtkExpression*) _tmp5_);
	_tmp6_ = unit_manager_get_default ();
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->category;
	_tmp9_ = unit_manager_get_category (_tmp7_, _tmp8_);
	_tmp10_ = _tmp9_;
	_g_object_unref0 (_tmp7_);
	c = _tmp10_;
	_tmp11_ = c;
	_tmp12_ = unit_category_get_units (_tmp11_);
	{
		GList* unit_collection = NULL;
		GList* unit_it = NULL;
		unit_collection = _tmp12_;
		for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
			Unit* _tmp13_;
			Unit* unit = NULL;
			_tmp13_ = _g_object_ref0 ((Unit*) unit_it->data);
			unit = _tmp13_;
			{
				GListStore* _tmp14_;
				Unit* _tmp15_;
				_tmp14_ = unit_model;
				_tmp15_ = unit;
				g_list_store_append (_tmp14_, (GObject*) _tmp15_);
				_g_object_unref0 (unit);
			}
		}
	}
	_tmp16_ = unit_model;
	model_size = g_list_model_get_n_items ((GListModel*) _tmp16_);
	_tmp17_ = self->priv->to_combo;
	_tmp18_ = unit_model;
	gtk_drop_down_set_model (_tmp17_, (GListModel*) _tmp18_);
	_tmp19_ = self->priv->to_combo;
	gtk_drop_down_set_enable_search (_tmp19_, model_size > ((guint) 10));
	_tmp20_ = self->priv->from_combo;
	_tmp21_ = unit_model;
	gtk_drop_down_set_model (_tmp20_, (GListModel*) _tmp21_);
	_tmp22_ = self->priv->from_combo;
	gtk_drop_down_set_enable_search (_tmp22_, model_size > ((guint) 10));
	_g_object_unref0 (c);
	_gtk_expression_unref0 (expression);
	_g_object_unref0 (unit_model);
}

static gboolean
math_converter_set_active_unit (MathConverter* self,
                                GtkDropDown* combo,
                                Unit* unit)
{
	guint position = 0U;
	GListStore* model = NULL;
	GListModel* _tmp0_;
	GListStore* _tmp1_;
	GListStore* _tmp2_;
	guint _tmp3_ = 0U;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (combo != NULL, FALSE);
	g_return_val_if_fail (unit != NULL, FALSE);
	position = (guint) 0;
	_tmp0_ = gtk_drop_down_get_model (combo);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_list_store_get_type ()) ? ((GListStore*) _tmp0_) : NULL);
	model = _tmp1_;
	_tmp2_ = model;
	g_list_store_find (_tmp2_, (GObject*) unit, &_tmp3_);
	position = _tmp3_;
	if (position == ((guint) -1)) {
		result = FALSE;
		_g_object_unref0 (model);
		return result;
	}
	gtk_drop_down_set_selected (combo, position);
	result = TRUE;
	_g_object_unref0 (model);
	return result;
}

static void
math_converter_category_combobox_changed_cb (MathConverter* self)
{
	UnitCategory* category = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	UnitCategory* _tmp3_;
	UnitCategory* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* source_currency = NULL;
	gchar* _tmp8_;
	gchar* target_currency = NULL;
	gchar* _tmp9_;
	MathEquation* _tmp10_;
	UnitCategory* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->category_combo;
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp2_) : NULL);
	category = _tmp3_;
	_tmp4_ = category;
	_tmp5_ = unit_category_get_name (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (self->priv->category);
	self->priv->category = _tmp6_;
	math_converter_update_visibility (self);
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
		GtkDropDown* _tmp7_;
		_tmp7_ = self->priv->from_combo;
		g_signal_handler_block (_tmp7_, self->priv->from_combobox_changed);
	}
	_tmp8_ = g_strdup ("");
	source_currency = _tmp8_;
	_tmp9_ = g_strdup ("");
	target_currency = _tmp9_;
	_tmp10_ = self->priv->_equation;
	if (_tmp10_ != NULL) {
		MathEquation* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		MathEquation* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp11_ = self->priv->_equation;
		_tmp12_ = math_equation_get_source_currency (_tmp11_);
		_tmp13_ = _tmp12_;
		_g_free0 (source_currency);
		source_currency = _tmp13_;
		_tmp14_ = self->priv->_equation;
		_tmp15_ = math_equation_get_target_currency (_tmp14_);
		_tmp16_ = _tmp15_;
		_g_free0 (target_currency);
		target_currency = _tmp16_;
	}
	math_converter_build_units_model (self);
	_tmp17_ = category;
	_tmp18_ = unit_category_get_name (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strcmp0 (_tmp20_, "currency") != 0;
	_g_free0 (_tmp20_);
	if (_tmp21_) {
		GtkDropDown* _tmp22_;
		_tmp22_ = self->priv->from_combo;
		gtk_drop_down_set_selected (_tmp22_, (guint) 0);
	} else {
		Unit* ua = NULL;
		UnitManager* _tmp23_;
		UnitManager* _tmp24_;
		const gchar* _tmp25_;
		Unit* _tmp26_;
		Unit* _tmp27_;
		Unit* ub = NULL;
		UnitManager* _tmp28_;
		UnitManager* _tmp29_;
		const gchar* _tmp30_;
		Unit* _tmp31_;
		Unit* _tmp32_;
		gboolean _tmp33_ = FALSE;
		Unit* _tmp34_;
		_tmp23_ = unit_manager_get_default ();
		_tmp24_ = _tmp23_;
		_tmp25_ = source_currency;
		_tmp26_ = unit_manager_get_unit_by_name (_tmp24_, _tmp25_);
		_tmp27_ = _tmp26_;
		_g_object_unref0 (_tmp24_);
		ua = _tmp27_;
		_tmp28_ = unit_manager_get_default ();
		_tmp29_ = _tmp28_;
		_tmp30_ = target_currency;
		_tmp31_ = unit_manager_get_unit_by_name (_tmp29_, _tmp30_);
		_tmp32_ = _tmp31_;
		_g_object_unref0 (_tmp29_);
		ub = _tmp32_;
		_tmp34_ = ua;
		if (_tmp34_ == NULL) {
			_tmp33_ = TRUE;
		} else {
			Unit* _tmp35_;
			_tmp35_ = ub;
			_tmp33_ = _tmp35_ == NULL;
		}
		if (_tmp33_) {
			GtkDropDown* _tmp36_;
			_tmp36_ = self->priv->from_combo;
			gtk_drop_down_set_selected (_tmp36_, (guint) 0);
		} else {
			GtkDropDown* _tmp37_;
			Unit* _tmp38_;
			GtkDropDown* _tmp39_;
			Unit* _tmp40_;
			_tmp37_ = self->priv->from_combo;
			_tmp38_ = ua;
			math_converter_set_active_unit (self, _tmp37_, _tmp38_);
			_tmp39_ = self->priv->to_combo;
			_tmp40_ = ub;
			math_converter_set_active_unit (self, _tmp39_, _tmp40_);
		}
		_g_object_unref0 (ub);
		_g_object_unref0 (ua);
	}
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
		GtkDropDown* _tmp41_;
		_tmp41_ = self->priv->from_combo;
		g_signal_handler_unblock (_tmp41_, self->priv->from_combobox_changed);
	}
	math_converter_to_combobox_changed_cb (self);
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL], 0);
	_g_free0 (target_currency);
	_g_free0 (source_currency);
	_g_object_unref0 (category);
}

static void
_math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
	math_converter_category_combobox_changed_cb ((MathConverter*) self);
}

static void
math_converter_from_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	MathEquation* _tmp13_;
	Serializer* _tmp14_;
	Serializer* _tmp15_;
	Number* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkTextView* _tmp19_;
	GtkTextBuffer* _tmp20_;
	GtkTextBuffer* _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->to_number;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->to_number;
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
	_g_object_unref0 (source_unit);
	source_unit = _tmp2_;
	_g_object_unref0 (target_unit);
	target_unit = _tmp3_;
	_g_object_unref0 (self->priv->from_number);
	self->priv->from_number = _tmp4_;
	_tmp5_ = self->priv->from_number;
	if (_tmp5_ == NULL) {
		Number* _tmp6_;
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
		_g_object_unref0 (self->priv->from_number);
		self->priv->from_number = _tmp6_;
	}
	_tmp7_ = self->priv->from_entry;
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
	_tmp9_ = _tmp8_;
	g_signal_handler_block (_tmp9_, self->priv->from_entry_changed);
	_tmp10_ = self->priv->from_entry;
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = self->priv->_equation;
	_tmp14_ = math_equation_get_serializer (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = self->priv->from_number;
	_tmp17_ = serializer_to_string (_tmp15_, _tmp16_);
	_tmp18_ = _tmp17_;
	g_object_set (_tmp12_, "text", _tmp18_, NULL);
	_g_free0 (_tmp18_);
	_tmp19_ = self->priv->from_entry;
	_tmp20_ = gtk_text_view_get_buffer (_tmp19_);
	_tmp21_ = _tmp20_;
	g_signal_handler_unblock (_tmp21_, self->priv->from_entry_changed);
	math_converter_save_selected_units (self);
	_g_object_unref0 (target_unit);
	_g_object_unref0 (source_unit);
}

static void
math_converter_to_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->from_number;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->from_number;
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
	_g_object_unref0 (source_unit);
	source_unit = _tmp2_;
	_g_object_unref0 (target_unit);
	target_unit = _tmp3_;
	_g_object_unref0 (self->priv->to_number);
	self->priv->to_number = _tmp4_;
	_tmp5_ = self->priv->to_number;
	if (_tmp5_ == NULL) {
		Number* _tmp6_;
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
		_g_object_unref0 (self->priv->to_number);
		self->priv->to_number = _tmp6_;
	}
	_tmp7_ = self->priv->to_entry;
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
	_tmp9_ = _tmp8_;
	g_signal_handler_block (_tmp9_, self->priv->to_entry_changed);
	_tmp10_ = self->priv->to_entry;
	g_object_get ((GtkWidget*) _tmp10_, "has-focus", &_tmp11_, NULL);
	_tmp12_ = _tmp11_;
	if (_tmp12_) {
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		Serializer* _tmp16_;
		Number* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp13_ = self->priv->to_entry;
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = self->priv->fixed_serializer;
		_tmp17_ = self->priv->to_number;
		_tmp18_ = serializer_to_string (_tmp16_, _tmp17_);
		_tmp19_ = _tmp18_;
		g_object_set (_tmp15_, "text", _tmp19_, NULL);
		_g_free0 (_tmp19_);
	} else {
		GtkTextView* _tmp20_;
		GtkTextBuffer* _tmp21_;
		GtkTextBuffer* _tmp22_;
		MathEquation* _tmp23_;
		Serializer* _tmp24_;
		Serializer* _tmp25_;
		Number* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp20_ = self->priv->to_entry;
		_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = self->priv->_equation;
		_tmp24_ = math_equation_get_serializer (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = self->priv->to_number;
		_tmp27_ = serializer_to_string (_tmp25_, _tmp26_);
		_tmp28_ = _tmp27_;
		g_object_set (_tmp22_, "text", _tmp28_, NULL);
		_g_free0 (_tmp28_);
	}
	_tmp29_ = self->priv->to_entry;
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
	_tmp31_ = _tmp30_;
	g_signal_handler_unblock (_tmp31_, self->priv->to_entry_changed);
	math_converter_save_selected_units (self);
	_g_object_unref0 (target_unit);
	_g_object_unref0 (source_unit);
}

static void
_math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
	math_converter_to_combobox_changed_cb ((MathConverter*) self);
}

static void
math_converter_save_selected_units (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
	const gchar* _tmp2_;
	MathEquation* _tmp13_;
	Unit* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	MathEquation* _tmp18_;
	Unit* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	g_return_if_fail (self != NULL);
	math_converter_get_conversion (self, &_tmp0_, &_tmp1_);
	_g_object_unref0 (from_unit);
	from_unit = _tmp0_;
	_g_object_unref0 (to_unit);
	to_unit = _tmp1_;
	_tmp2_ = self->priv->category;
	if (g_strcmp0 (_tmp2_, "currency") == 0) {
		MathEquation* _tmp3_;
		Unit* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		MathEquation* _tmp8_;
		Unit* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp3_ = self->priv->_equation;
		_tmp4_ = from_unit;
		_tmp5_ = unit_get_name (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = _tmp6_;
		math_equation_set_source_currency (_tmp3_, _tmp7_);
		_g_free0 (_tmp7_);
		_tmp8_ = self->priv->_equation;
		_tmp9_ = to_unit;
		_tmp10_ = unit_get_name (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp11_;
		math_equation_set_target_currency (_tmp8_, _tmp12_);
		_g_free0 (_tmp12_);
	}
	_tmp13_ = self->priv->_equation;
	_tmp14_ = from_unit;
	_tmp15_ = unit_get_name (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = _tmp16_;
	math_equation_set_source_units (_tmp13_, _tmp17_);
	_g_free0 (_tmp17_);
	_tmp18_ = self->priv->_equation;
	_tmp19_ = to_unit;
	_tmp20_ = unit_get_name (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = _tmp21_;
	math_equation_set_target_units (_tmp18_, _tmp22_);
	_g_free0 (_tmp22_);
	_g_object_unref0 (to_unit);
	_g_object_unref0 (from_unit);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
math_converter_from_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextBuffer* _tmp35_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->from_entry;
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_handler_block (_tmp2_, self->priv->from_entry_changed);
	_tmp3_ = self->priv->from_entry;
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		Serializer* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp6_ = self->priv->from_entry;
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = self->priv->fixed_serializer;
		_tmp10_ = self->priv->from_number;
		_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
		_tmp12_ = _tmp11_;
		g_object_set (_tmp8_, "text", _tmp12_, NULL);
		_g_free0 (_tmp12_);
	} else {
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		GtkTextView* _tmp24_;
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		MathEquation* _tmp27_;
		Serializer* _tmp28_;
		Serializer* _tmp29_;
		Number* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		_tmp13_ = self->priv->from_entry;
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
		_tmp15_ = _tmp14_;
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_;
		_tmp19_ = string_strip (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = math_converter_get_number_from_string (self, _tmp20_);
		_g_object_unref0 (self->priv->from_number);
		self->priv->from_number = _tmp21_;
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		_tmp22_ = self->priv->from_number;
		if (_tmp22_ == NULL) {
			Number* _tmp23_;
			_tmp23_ = number_new_integer ((gint64) 0, (gint64) 0);
			_g_object_unref0 (self->priv->from_number);
			self->priv->from_number = _tmp23_;
		}
		_tmp24_ = self->priv->from_entry;
		_tmp25_ = gtk_text_view_get_buffer (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = self->priv->_equation;
		_tmp28_ = math_equation_get_serializer (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = self->priv->from_number;
		_tmp31_ = serializer_to_string (_tmp29_, _tmp30_);
		_tmp32_ = _tmp31_;
		g_object_set (_tmp26_, "text", _tmp32_, NULL);
		_g_free0 (_tmp32_);
	}
	_tmp33_ = self->priv->from_entry;
	_tmp34_ = gtk_text_view_get_buffer (_tmp33_);
	_tmp35_ = _tmp34_;
	g_signal_handler_unblock (_tmp35_, self->priv->from_entry_changed);
}

static void
_math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	math_converter_from_entry_focus_cb ((MathConverter*) self);
}

static void
math_converter_to_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextBuffer* _tmp35_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->to_entry;
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_handler_block (_tmp2_, self->priv->to_entry_changed);
	_tmp3_ = self->priv->to_entry;
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		Serializer* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp6_ = self->priv->to_entry;
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = self->priv->fixed_serializer;
		_tmp10_ = self->priv->to_number;
		_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
		_tmp12_ = _tmp11_;
		g_object_set (_tmp8_, "text", _tmp12_, NULL);
		_g_free0 (_tmp12_);
	} else {
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		GtkTextView* _tmp24_;
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		MathEquation* _tmp27_;
		Serializer* _tmp28_;
		Serializer* _tmp29_;
		Number* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		_tmp13_ = self->priv->to_entry;
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
		_tmp15_ = _tmp14_;
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_;
		_tmp19_ = string_strip (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = math_converter_get_number_from_string (self, _tmp20_);
		_g_object_unref0 (self->priv->to_number);
		self->priv->to_number = _tmp21_;
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		_tmp22_ = self->priv->to_number;
		if (_tmp22_ == NULL) {
			Number* _tmp23_;
			_tmp23_ = number_new_integer ((gint64) 0, (gint64) 0);
			_g_object_unref0 (self->priv->to_number);
			self->priv->to_number = _tmp23_;
		}
		_tmp24_ = self->priv->to_entry;
		_tmp25_ = gtk_text_view_get_buffer (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = self->priv->_equation;
		_tmp28_ = math_equation_get_serializer (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = self->priv->to_number;
		_tmp31_ = serializer_to_string (_tmp29_, _tmp30_);
		_tmp32_ = _tmp31_;
		g_object_set (_tmp26_, "text", _tmp32_, NULL);
		_g_free0 (_tmp32_);
	}
	_tmp33_ = self->priv->to_entry;
	_tmp34_ = gtk_text_view_get_buffer (_tmp33_);
	_tmp35_ = _tmp34_;
	g_signal_handler_unblock (_tmp35_, self->priv->to_entry_changed);
}

static void
_math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	math_converter_to_entry_focus_cb ((MathConverter*) self);
}

static void
math_converter_from_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp11_;
	Unit* _tmp12_ = NULL;
	Unit* _tmp13_ = NULL;
	Number* _tmp14_;
	Number* _tmp15_;
	GtkTextView* _tmp17_;
	GtkTextBuffer* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextView* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GtkTextView* _tmp39_;
	GtkTextBuffer* _tmp40_;
	GtkTextBuffer* _tmp41_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->from_entry;
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
	_tmp2_ = _tmp1_;
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp6_ = string_strip (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = math_converter_get_number_from_string (self, _tmp7_);
	_g_object_unref0 (self->priv->from_number);
	self->priv->from_number = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_tmp9_ = self->priv->from_number;
	if (_tmp9_ == NULL) {
		Number* _tmp10_;
		_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
		_g_object_unref0 (self->priv->from_number);
		self->priv->from_number = _tmp10_;
	}
	_tmp11_ = self->priv->from_number;
	_tmp14_ = math_converter_convert_equation (self, _tmp11_, &_tmp12_, &_tmp13_);
	_g_object_unref0 (source_unit);
	source_unit = _tmp12_;
	_g_object_unref0 (target_unit);
	target_unit = _tmp13_;
	_g_object_unref0 (self->priv->to_number);
	self->priv->to_number = _tmp14_;
	_tmp15_ = self->priv->to_number;
	if (_tmp15_ == NULL) {
		Number* _tmp16_;
		_tmp16_ = number_new_integer ((gint64) 0, (gint64) 0);
		_g_object_unref0 (self->priv->to_number);
		self->priv->to_number = _tmp16_;
	}
	_tmp17_ = self->priv->to_entry;
	_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
	_tmp19_ = _tmp18_;
	g_signal_handler_block (_tmp19_, self->priv->to_entry_changed);
	_tmp20_ = self->priv->to_entry;
	g_object_get ((GtkWidget*) _tmp20_, "has-focus", &_tmp21_, NULL);
	_tmp22_ = _tmp21_;
	if (_tmp22_) {
		GtkTextView* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextBuffer* _tmp25_;
		Serializer* _tmp26_;
		Number* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		_tmp23_ = self->priv->to_entry;
		_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = self->priv->fixed_serializer;
		_tmp27_ = self->priv->to_number;
		_tmp28_ = serializer_to_string (_tmp26_, _tmp27_);
		_tmp29_ = _tmp28_;
		g_object_set (_tmp25_, "text", _tmp29_, NULL);
		_g_free0 (_tmp29_);
	} else {
		GtkTextView* _tmp30_;
		GtkTextBuffer* _tmp31_;
		GtkTextBuffer* _tmp32_;
		MathEquation* _tmp33_;
		Serializer* _tmp34_;
		Serializer* _tmp35_;
		Number* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		_tmp30_ = self->priv->to_entry;
		_tmp31_ = gtk_text_view_get_buffer (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = self->priv->_equation;
		_tmp34_ = math_equation_get_serializer (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = self->priv->to_number;
		_tmp37_ = serializer_to_string (_tmp35_, _tmp36_);
		_tmp38_ = _tmp37_;
		g_object_set (_tmp32_, "text", _tmp38_, NULL);
		_g_free0 (_tmp38_);
	}
	_tmp39_ = self->priv->to_entry;
	_tmp40_ = gtk_text_view_get_buffer (_tmp39_);
	_tmp41_ = _tmp40_;
	g_signal_handler_unblock (_tmp41_, self->priv->to_entry_changed);
	_g_object_unref0 (target_unit);
	_g_object_unref0 (source_unit);
}

static void
math_converter_to_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp11_;
	Unit* _tmp12_ = NULL;
	Unit* _tmp13_ = NULL;
	Number* _tmp14_;
	Number* _tmp15_;
	GtkTextView* _tmp17_;
	GtkTextBuffer* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextView* _tmp20_;
	GtkTextBuffer* _tmp21_;
	GtkTextBuffer* _tmp22_;
	MathEquation* _tmp23_;
	Serializer* _tmp24_;
	Serializer* _tmp25_;
	Number* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->to_entry;
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
	_tmp2_ = _tmp1_;
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp6_ = string_strip (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = math_converter_get_number_from_string (self, _tmp7_);
	_g_object_unref0 (self->priv->to_number);
	self->priv->to_number = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_tmp9_ = self->priv->to_number;
	if (_tmp9_ == NULL) {
		Number* _tmp10_;
		_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
		_g_object_unref0 (self->priv->to_number);
		self->priv->to_number = _tmp10_;
	}
	_tmp11_ = self->priv->to_number;
	_tmp14_ = math_converter_convert_equation (self, _tmp11_, &_tmp12_, &_tmp13_);
	_g_object_unref0 (source_unit);
	source_unit = _tmp12_;
	_g_object_unref0 (target_unit);
	target_unit = _tmp13_;
	_g_object_unref0 (self->priv->from_number);
	self->priv->from_number = _tmp14_;
	_tmp15_ = self->priv->from_number;
	if (_tmp15_ == NULL) {
		Number* _tmp16_;
		_tmp16_ = number_new_integer ((gint64) 0, (gint64) 0);
		_g_object_unref0 (self->priv->from_number);
		self->priv->from_number = _tmp16_;
	}
	_tmp17_ = self->priv->from_entry;
	_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
	_tmp19_ = _tmp18_;
	g_signal_handler_block (_tmp19_, self->priv->from_entry_changed);
	_tmp20_ = self->priv->from_entry;
	_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = self->priv->_equation;
	_tmp24_ = math_equation_get_serializer (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = self->priv->from_number;
	_tmp27_ = serializer_to_string (_tmp25_, _tmp26_);
	_tmp28_ = _tmp27_;
	g_object_set (_tmp22_, "text", _tmp28_, NULL);
	_g_free0 (_tmp28_);
	_tmp29_ = self->priv->from_entry;
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
	_tmp31_ = _tmp30_;
	g_signal_handler_unblock (_tmp31_, self->priv->from_entry_changed);
	_g_object_unref0 (target_unit);
	_g_object_unref0 (source_unit);
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static Number*
math_converter_get_number_from_string (MathConverter* self,
                                       const gchar* str)
{
	gboolean _tmp1_ = FALSE;
	Serializer* _tmp19_;
	Number* _tmp20_;
	Number* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (str != NULL, NULL);
	if (g_strcmp0 (str, "π") == 0) {
		Number* _tmp0_;
		_tmp0_ = number_new_pi ();
		result = _tmp0_;
		return result;
	}
	if (g_strcmp0 (str, "−π") == 0) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = g_strcmp0 (str, "-π") == 0;
	}
	if (_tmp1_) {
		Number* _tmp2_;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
		_tmp2_ = number_new_pi ();
		_tmp3_ = _tmp2_;
		_tmp4_ = number_invert_sign (_tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		result = _tmp5_;
		return result;
	}
	if (g_str_has_suffix (str, "π")) {
		Number* number = NULL;
		Serializer* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		Number* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
		Number* _tmp16_;
		Number* _tmp17_;
		Number* _tmp18_;
		_tmp6_ = self->priv->fixed_serializer;
		_tmp7_ = strlen ("π");
		_tmp8_ = _tmp7_;
		_tmp9_ = string_slice (str, (glong) 0, (glong) (-_tmp8_));
		_tmp10_ = _tmp9_;
		_tmp11_ = serializer_from_string (_tmp6_, _tmp10_);
		_tmp12_ = _tmp11_;
		_g_free0 (_tmp10_);
		number = _tmp12_;
		_tmp13_ = number;
		if (_tmp13_ == NULL) {
			result = NULL;
			_g_object_unref0 (number);
			return result;
		}
		_tmp14_ = number_new_pi ();
		_tmp15_ = _tmp14_;
		_tmp16_ = number;
		_tmp17_ = number_multiply (_tmp15_, _tmp16_);
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp15_);
		result = _tmp18_;
		_g_object_unref0 (number);
		return result;
	}
	_tmp19_ = self->priv->fixed_serializer;
	_tmp20_ = serializer_from_string (_tmp19_, str);
	result = _tmp20_;
	return result;
}

static gboolean
math_converter_key_press_cb (MathConverter* self,
                             GtkEventControllerKey* controller,
                             guint keyval,
                             guint keycode,
                             GdkModifierType mod_state)
{
	GdkModifierType state = 0U;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint new_keyval = 0U;
	guint32 c = 0U;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (controller != NULL, FALSE);
	state = mod_state & (GDK_CONTROL_MASK | GDK_ALT_MASK);
	if (keyval == GDK_KEY_Escape) {
		_tmp1_ = state == 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		if (keyval == GDK_KEY_Delete) {
			_tmp2_ = (mod_state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
		} else {
			_tmp2_ = FALSE;
		}
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		math_converter_clear (self);
		result = TRUE;
		return result;
	}
	new_keyval = (guint) 0;
	switch (keyval) {
		case GDK_KEY_KP_Insert:
		{
			new_keyval = GDK_KEY_0;
			break;
		}
		case GDK_KEY_KP_End:
		{
			new_keyval = GDK_KEY_1;
			break;
		}
		case GDK_KEY_KP_Down:
		{
			new_keyval = GDK_KEY_2;
			break;
		}
		case GDK_KEY_KP_Page_Down:
		{
			new_keyval = GDK_KEY_3;
			break;
		}
		case GDK_KEY_KP_Left:
		{
			new_keyval = GDK_KEY_4;
			break;
		}
		case GDK_KEY_KP_Begin:
		{
			new_keyval = GDK_KEY_5;
			break;
		}
		case GDK_KEY_KP_Right:
		{
			new_keyval = GDK_KEY_6;
			break;
		}
		case GDK_KEY_KP_Home:
		{
			new_keyval = GDK_KEY_7;
			break;
		}
		case GDK_KEY_KP_Up:
		{
			new_keyval = GDK_KEY_8;
			break;
		}
		case GDK_KEY_KP_Page_Up:
		{
			new_keyval = GDK_KEY_9;
			break;
		}
		case GDK_KEY_KP_Delete:
		{
			new_keyval = GDK_KEY_period;
			break;
		}
		default:
		break;
	}
	if (new_keyval != ((guint) 0)) {
		g_info ("math-converter.vala:502: forwarding\n");
		result = math_converter_key_press_cb (self, controller, new_keyval, keycode, mod_state);
		return result;
	}
	c = gdk_keyval_to_unicode (keyval);
	if (keyval == GDK_KEY_Return) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = keyval == GDK_KEY_KP_Enter;
	}
	if (_tmp3_) {
		result = TRUE;
		return result;
	}
	if (keyval == GDK_KEY_KP_Decimal) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = keyval == GDK_KEY_KP_Separator;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = keyval == GDK_KEY_period;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = keyval == GDK_KEY_decimalpoint;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		_tmp4_ = keyval == GDK_KEY_comma;
	}
	if (_tmp4_) {
		math_converter_insert_numeric_point (self);
		result = TRUE;
		return result;
	}
	if (state == 0) {
		gboolean _tmp8_ = FALSE;
		if (c >= ((guint32) '0')) {
			_tmp8_ = c <= ((guint32) '9');
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp9_ = g_strdup_printf ("%c", c);
			_tmp10_ = _tmp9_;
			math_converter_insert_text (self, _tmp10_);
			_g_free0 (_tmp10_);
			result = TRUE;
			return result;
		}
		if (c == ((guint32) '-')) {
			math_converter_insert_text (self, "−");
			result = TRUE;
			return result;
		}
	}
	if (state == GDK_CONTROL_MASK) {
		_tmp11_ = keyval == GDK_KEY_p;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		math_converter_insert_text (self, "π");
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
_math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                   guint keyval,
                                                                   guint keycode,
                                                                   GdkModifierType state,
                                                                   gpointer self)
{
	gboolean result;
	result = math_converter_key_press_cb ((MathConverter*) self, _sender, keyval, keycode, state);
	return result;
}

static gpointer
_gdk_event_ref0 (gpointer self)
{
	return self ? gdk_event_ref (self) : NULL;
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
	g_boxed_free (gdk_event_sequence_get_type (), self);
}

static void
math_converter_from_entry_click_cb (MathConverter* self,
                                    GtkGestureClick* gesture,
                                    gint n_click,
                                    gdouble x,
                                    gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
	_tmp4_ = _tmp3_;
	__vala_GdkEventSequence_free0 (_tmp1_);
	event = _tmp4_;
	_tmp5_ = event;
	if (gdk_event_triggers_context_menu (_tmp5_)) {
		GtkTextView* _tmp6_;
		_tmp6_ = self->priv->from_entry;
		math_converter_show_context_menu (self, _tmp6_, x, y);
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
	}
	_gdk_event_unref0 (event);
}

static void
_math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
	math_converter_from_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
}

static void
math_converter_to_entry_click_cb (MathConverter* self,
                                  GtkGestureClick* gesture,
                                  gint n_click,
                                  gdouble x,
                                  gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
	_tmp4_ = _tmp3_;
	__vala_GdkEventSequence_free0 (_tmp1_);
	event = _tmp4_;
	_tmp5_ = event;
	if (gdk_event_triggers_context_menu (_tmp5_)) {
		GtkTextView* _tmp6_;
		_tmp6_ = self->priv->to_entry;
		math_converter_show_context_menu (self, _tmp6_, x, y);
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
	}
	_gdk_event_unref0 (event);
}

static void
_math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self)
{
	math_converter_to_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
}

static void
math_converter_show_context_menu (MathConverter* self,
                                  GtkTextView* entry,
                                  gdouble x,
                                  gdouble y)
{
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
	gboolean can_paste = FALSE;
	GdkClipboard* _tmp3_;
	GdkContentFormats* _tmp4_;
	GtkRoot* _tmp5_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_ = {0};
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextIter _tmp12_;
	GtkTextIter _tmp13_;
	GtkPopoverMenu* _tmp14_ = NULL;
	GtkTextView* _tmp15_;
	GtkPopoverMenu* context_menu = NULL;
	GtkPopoverMenu* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GtkPopoverMenu* _tmp23_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = gdk_display_get_clipboard (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	clipboard = _tmp2_;
	_tmp3_ = clipboard;
	_tmp4_ = gdk_clipboard_get_formats (_tmp3_);
	can_paste = gdk_content_formats_contain_gtype (_tmp4_, G_TYPE_STRING);
	gtk_widget_action_set_enabled ((GtkWidget*) self, "context-menu.paste", can_paste);
	_tmp5_ = gtk_widget_get_root ((GtkWidget*) self);
	gtk_root_set_focus (_tmp5_, NULL);
	_tmp6_ = gtk_text_view_get_buffer (entry);
	_tmp7_ = _tmp6_;
	gtk_text_buffer_get_bounds (_tmp7_, &_tmp8_, &_tmp9_);
	start = _tmp8_;
	end = _tmp9_;
	_tmp10_ = gtk_text_view_get_buffer (entry);
	_tmp11_ = _tmp10_;
	_tmp12_ = start;
	_tmp13_ = end;
	gtk_text_buffer_select_range (_tmp11_, &_tmp12_, &_tmp13_);
	_tmp15_ = self->priv->from_entry;
	if (entry == _tmp15_) {
		GtkPopoverMenu* _tmp16_;
		_tmp16_ = self->priv->from_context_menu;
		_tmp14_ = _tmp16_;
	} else {
		GtkPopoverMenu* _tmp17_;
		_tmp17_ = self->priv->to_context_menu;
		_tmp14_ = _tmp17_;
	}
	_tmp18_ = _g_object_ref0 (_tmp14_);
	context_menu = _tmp18_;
	if (x != ((gdouble) -1)) {
		_tmp19_ = y != ((gdouble) -1);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		GtkPopoverMenu* _tmp20_;
		GdkRectangle _tmp21_ = {0};
		_tmp20_ = context_menu;
		_tmp21_.x = (gint) x;
		_tmp21_.y = (gint) y;
		_tmp21_.width = 1;
		_tmp21_.height = 1;
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp20_, &_tmp21_);
	} else {
		GtkPopoverMenu* _tmp22_;
		_tmp22_ = context_menu;
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp22_, NULL);
	}
	_tmp23_ = context_menu;
	gtk_popover_popup ((GtkPopover*) _tmp23_);
	_g_object_unref0 (context_menu);
	_g_object_unref0 (clipboard);
}

static void
math_converter_popup_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp1_ = self->priv->from_entry;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkTextView* _tmp4_;
		_tmp4_ = self->priv->from_entry;
		_tmp0_ = _tmp4_;
	} else {
		GtkTextView* _tmp5_;
		_tmp5_ = self->priv->to_entry;
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp0_);
	entry = _tmp6_;
	math_converter_show_context_menu (self, entry, (gdouble) -1, (gdouble) -1);
	_g_object_unref0 (entry);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
math_converter_copy_cb (MathConverter* self,
                        GSimpleAction* action,
                        GVariant* param)
{
	Number* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	Number* number = NULL;
	Number* _tmp6_;
	gchar* text = NULL;
	MathEquation* _tmp7_;
	Serializer* _tmp8_;
	Serializer* _tmp9_;
	Number* _tmp10_;
	gchar* _tmp11_;
	gchar* tsep_string = NULL;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp21_;
	GdkClipboard* _tmp22_;
	GdkClipboard* _tmp23_;
	const gchar* _tmp24_;
	GtkRoot* _tmp25_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp1_ = self->priv->from_entry;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		Number* _tmp4_;
		_tmp4_ = self->priv->from_number;
		_tmp0_ = _tmp4_;
	} else {
		Number* _tmp5_;
		_tmp5_ = self->priv->to_number;
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp0_);
	number = _tmp6_;
	_tmp7_ = self->priv->_equation;
	_tmp8_ = math_equation_get_serializer (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = number;
	_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
	text = _tmp11_;
	_tmp12_ = nl_langinfo (THOUSEP);
	_tmp13_ = g_strdup (_tmp12_);
	tsep_string = _tmp13_;
	_tmp15_ = tsep_string;
	if (_tmp15_ == NULL) {
		_tmp14_ = TRUE;
	} else {
		const gchar* _tmp16_;
		_tmp16_ = tsep_string;
		_tmp14_ = g_strcmp0 (_tmp16_, "") == 0;
	}
	if (_tmp14_) {
		gchar* _tmp17_;
		_tmp17_ = g_strdup (" ");
		_g_free0 (tsep_string);
		tsep_string = _tmp17_;
	}
	_tmp18_ = text;
	_tmp19_ = tsep_string;
	_tmp20_ = string_replace (_tmp18_, _tmp19_, "");
	_g_free0 (text);
	text = _tmp20_;
	_tmp21_ = gdk_display_get_default ();
	_tmp22_ = gdk_display_get_clipboard (_tmp21_);
	_tmp23_ = _g_object_ref0 (_tmp22_);
	clipboard = _tmp23_;
	_tmp24_ = text;
	gdk_clipboard_set_text (clipboard, _tmp24_);
	_tmp25_ = gtk_widget_get_root ((GtkWidget*) self);
	gtk_root_set_focus (_tmp25_, NULL);
	_g_object_unref0 (clipboard);
	_g_free0 (tsep_string);
	_g_free0 (text);
	_g_object_unref0 (number);
}

static void
math_converter_paste_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp1_ = self->priv->from_entry;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkTextView* _tmp4_;
		_tmp4_ = self->priv->from_entry;
		_tmp0_ = _tmp4_;
	} else {
		GtkTextView* _tmp5_;
		_tmp5_ = self->priv->to_entry;
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp0_);
	entry = _tmp6_;
	_tmp7_ = gtk_text_view_get_buffer (entry);
	_tmp8_ = _tmp7_;
	g_object_set (_tmp8_, "text", "", NULL);
	math_converter_paste (self);
	_g_object_unref0 (entry);
}

static void
math_converter_reformat_display (MathConverter* self)
{
	Serializer* _tmp0_;
	MathEquation* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkTextView* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkTextView* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->fixed_serializer;
	_tmp1_ = self->priv->_equation;
	_tmp2_ = math_equation_get_accuracy (_tmp1_);
	_tmp3_ = _tmp2_;
	if (serializer_get_trailing_digits (_tmp0_) != _tmp3_) {
		Serializer* _tmp4_;
		MathEquation* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		_tmp4_ = self->priv->fixed_serializer;
		_tmp5_ = self->priv->_equation;
		_tmp6_ = math_equation_get_accuracy (_tmp5_);
		_tmp7_ = _tmp6_;
		serializer_set_trailing_digits (_tmp4_, _tmp7_);
	}
	_tmp8_ = self->priv->from_entry;
	g_object_get ((GtkWidget*) _tmp8_, "has-focus", &_tmp9_, NULL);
	_tmp10_ = _tmp9_;
	if (!_tmp10_) {
		GtkTextView* _tmp11_;
		GtkTextBuffer* _tmp12_;
		GtkTextBuffer* _tmp13_;
		GtkTextView* _tmp14_;
		GtkTextBuffer* _tmp15_;
		GtkTextBuffer* _tmp16_;
		MathEquation* _tmp17_;
		Serializer* _tmp18_;
		Serializer* _tmp19_;
		Number* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkTextView* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextBuffer* _tmp25_;
		_tmp11_ = self->priv->from_entry;
		_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
		_tmp13_ = _tmp12_;
		g_signal_handler_block (_tmp13_, self->priv->from_entry_changed);
		_tmp14_ = self->priv->from_entry;
		_tmp15_ = gtk_text_view_get_buffer (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = self->priv->_equation;
		_tmp18_ = math_equation_get_serializer (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = self->priv->from_number;
		_tmp21_ = serializer_to_string (_tmp19_, _tmp20_);
		_tmp22_ = _tmp21_;
		g_object_set (_tmp16_, "text", _tmp22_, NULL);
		_g_free0 (_tmp22_);
		_tmp23_ = self->priv->from_entry;
		_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
		_tmp25_ = _tmp24_;
		g_signal_handler_unblock (_tmp25_, self->priv->from_entry_changed);
	}
	_tmp26_ = self->priv->to_entry;
	g_object_get ((GtkWidget*) _tmp26_, "has-focus", &_tmp27_, NULL);
	_tmp28_ = _tmp27_;
	if (!_tmp28_) {
		GtkTextView* _tmp29_;
		GtkTextBuffer* _tmp30_;
		GtkTextBuffer* _tmp31_;
		GtkTextView* _tmp32_;
		GtkTextBuffer* _tmp33_;
		GtkTextBuffer* _tmp34_;
		MathEquation* _tmp35_;
		Serializer* _tmp36_;
		Serializer* _tmp37_;
		Number* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		GtkTextView* _tmp41_;
		GtkTextBuffer* _tmp42_;
		GtkTextBuffer* _tmp43_;
		_tmp29_ = self->priv->to_entry;
		_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
		_tmp31_ = _tmp30_;
		g_signal_handler_block (_tmp31_, self->priv->to_entry_changed);
		_tmp32_ = self->priv->to_entry;
		_tmp33_ = gtk_text_view_get_buffer (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp35_ = self->priv->_equation;
		_tmp36_ = math_equation_get_serializer (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = self->priv->to_number;
		_tmp39_ = serializer_to_string (_tmp37_, _tmp38_);
		_tmp40_ = _tmp39_;
		g_object_set (_tmp34_, "text", _tmp40_, NULL);
		_g_free0 (_tmp40_);
		_tmp41_ = self->priv->to_entry;
		_tmp42_ = gtk_text_view_get_buffer (_tmp41_);
		_tmp43_ = _tmp42_;
		g_signal_handler_unblock (_tmp43_, self->priv->to_entry_changed);
	}
}

void
math_converter_swap_units (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
	GtkDropDown* _tmp2_;
	GtkDropDown* _tmp3_;
	GtkDropDown* _tmp4_;
	GtkDropDown* _tmp5_;
	g_return_if_fail (self != NULL);
	math_converter_get_conversion (self, &_tmp0_, &_tmp1_);
	_g_object_unref0 (from_unit);
	from_unit = _tmp0_;
	_g_object_unref0 (to_unit);
	to_unit = _tmp1_;
	_tmp2_ = self->priv->from_combo;
	g_signal_handler_block (_tmp2_, self->priv->from_combobox_changed);
	_tmp3_ = self->priv->from_combo;
	math_converter_set_active_unit (self, _tmp3_, to_unit);
	_tmp4_ = self->priv->from_combo;
	g_signal_handler_unblock (_tmp4_, self->priv->from_combobox_changed);
	_tmp5_ = self->priv->to_combo;
	math_converter_set_active_unit (self, _tmp5_, from_unit);
	_g_object_unref0 (to_unit);
	_g_object_unref0 (from_unit);
}

static Number*
math_converter_convert_equation (MathConverter* self,
                                 Number* x,
                                 Unit** source_unit,
                                 Unit** target_unit)
{
	Unit* _vala_source_unit = NULL;
	Unit* _vala_target_unit = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkDropDown* _tmp2_;
	UnitCategory* category = NULL;
	GtkDropDown* _tmp5_;
	GObject* _tmp6_;
	GObject* _tmp7_;
	UnitCategory* _tmp8_;
	GtkDropDown* _tmp9_;
	GObject* _tmp10_;
	GObject* _tmp11_;
	Unit* _tmp12_;
	GtkDropDown* _tmp13_;
	GObject* _tmp14_;
	GObject* _tmp15_;
	Unit* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	UnitCategory* _tmp19_;
	Number* _tmp22_;
	Number* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (x != NULL, NULL);
	_tmp2_ = self->priv->category_combo;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		GtkDropDown* _tmp3_;
		_tmp3_ = self->priv->from_combo;
		_tmp1_ = _tmp3_ == NULL;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		GtkDropDown* _tmp4_;
		_tmp4_ = self->priv->to_combo;
		_tmp0_ = _tmp4_ == NULL;
	}
	if (_tmp0_) {
		result = NULL;
		if (source_unit) {
			*source_unit = _vala_source_unit;
		} else {
			_g_object_unref0 (_vala_source_unit);
		}
		if (target_unit) {
			*target_unit = _vala_target_unit;
		} else {
			_g_object_unref0 (_vala_target_unit);
		}
		return result;
	}
	_tmp5_ = self->priv->category_combo;
	_tmp6_ = gtk_drop_down_get_selected_item (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp7_) : NULL);
	category = _tmp8_;
	_tmp9_ = self->priv->from_combo;
	_tmp10_ = gtk_drop_down_get_selected_item (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, TYPE_UNIT) ? ((Unit*) _tmp11_) : NULL);
	_g_object_unref0 (_vala_source_unit);
	_vala_source_unit = _tmp12_;
	_tmp13_ = self->priv->to_combo;
	_tmp14_ = gtk_drop_down_get_selected_item (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, TYPE_UNIT) ? ((Unit*) _tmp15_) : NULL);
	_g_object_unref0 (_vala_target_unit);
	_vala_target_unit = _tmp16_;
	_tmp19_ = category;
	if (_tmp19_ == NULL) {
		_tmp18_ = TRUE;
	} else {
		Unit* _tmp20_;
		_tmp20_ = _vala_source_unit;
		_tmp18_ = _tmp20_ == NULL;
	}
	if (_tmp18_) {
		_tmp17_ = TRUE;
	} else {
		Unit* _tmp21_;
		_tmp21_ = _vala_target_unit;
		_tmp17_ = _tmp21_ == NULL;
	}
	if (_tmp17_) {
		result = NULL;
		_g_object_unref0 (category);
		if (source_unit) {
			*source_unit = _vala_source_unit;
		} else {
			_g_object_unref0 (_vala_source_unit);
		}
		if (target_unit) {
			*target_unit = _vala_target_unit;
		} else {
			_g_object_unref0 (_vala_target_unit);
		}
		return result;
	}
	_tmp22_ = self->priv->from_number;
	if (x == _tmp22_) {
		UnitCategory* _tmp23_;
		Unit* _tmp24_;
		Unit* _tmp25_;
		Number* _tmp26_;
		_tmp23_ = category;
		_tmp24_ = _vala_source_unit;
		_tmp25_ = _vala_target_unit;
		_tmp26_ = unit_category_convert (_tmp23_, x, _tmp24_, _tmp25_);
		result = _tmp26_;
		_g_object_unref0 (category);
		if (source_unit) {
			*source_unit = _vala_source_unit;
		} else {
			_g_object_unref0 (_vala_source_unit);
		}
		if (target_unit) {
			*target_unit = _vala_target_unit;
		} else {
			_g_object_unref0 (_vala_target_unit);
		}
		return result;
	} else {
		UnitCategory* _tmp27_;
		Unit* _tmp28_;
		Unit* _tmp29_;
		Number* _tmp30_;
		_tmp27_ = category;
		_tmp28_ = _vala_target_unit;
		_tmp29_ = _vala_source_unit;
		_tmp30_ = unit_category_convert (_tmp27_, x, _tmp28_, _tmp29_);
		result = _tmp30_;
		_g_object_unref0 (category);
		if (source_unit) {
			*source_unit = _vala_source_unit;
		} else {
			_g_object_unref0 (_vala_source_unit);
		}
		if (target_unit) {
			*target_unit = _vala_target_unit;
		} else {
			_g_object_unref0 (_vala_target_unit);
		}
		return result;
	}
}

MathEquation*
math_converter_get_equation (MathConverter* self)
{
	MathEquation* result;
	MathEquation* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_equation;
	result = _tmp0_;
	return result;
}

void
math_converter_set_equation (MathConverter* self,
                             MathEquation* value)
{
	MathEquation* old_value;
	g_return_if_fail (self != NULL);
	old_value = math_converter_get_equation (self);
	if (old_value != value) {
		MathEquation* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_equation);
		self->priv->_equation = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY]);
	}
}

gboolean
math_converter_get_outer_box_visible (MathConverter* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_outer_box_visible;
	return result;
}

void
math_converter_set_outer_box_visible (MathConverter* self,
                                      gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = math_converter_get_outer_box_visible (self);
	if (old_value != value) {
		self->priv->_outer_box_visible = value;
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY]);
	}
}

static void
_math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
	math_converter_construct_finish ((MathConverter*) self);
}

static GObject *
math_converter_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MathConverter * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	parent_class = G_OBJECT_CLASS (math_converter_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
	_tmp0_ = self->priv->action_group;
	g_action_map_add_action_entries ((GActionMap*) _tmp0_, MATH_CONVERTER_action_entries, (gint) G_N_ELEMENTS (MATH_CONVERTER_action_entries), self);
	_tmp1_ = self->priv->action_group;
	gtk_widget_insert_action_group ((GtkWidget*) self, "context-menu", (GActionGroup*) _tmp1_);
	g_signal_connect_object ((GObject*) self, "notify::equation", (GCallback) _math_converter_construct_finish_g_object_notify, self, 0);
	return obj;
}

static void
math_converter_class_init (MathConverterClass * klass,
                           gpointer klass_data)
{
	math_converter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MathConverter_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_math_converter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_math_converter_set_property;
	G_OBJECT_CLASS (klass)->constructor = math_converter_constructor;
	G_OBJECT_CLASS (klass)->finalize = math_converter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_EQUATION_PROPERTY, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY] = g_param_spec_object ("equation", "equation", "equation", TYPE_MATH_EQUATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY, math_converter_properties[MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY] = g_param_spec_boolean ("outer-box-visible", "outer-box-visible", "outer-box-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-converter.ui");
	math_converter_signals[MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL] = g_signal_new ("category-changed", TYPE_MATH_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "category_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, category_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_combo));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_entry));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_entry));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_context_menu));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_context_menu));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_event_controller));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_event_controller));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "category_combobox_changed_cb", G_CALLBACK(_math_converter_category_combobox_changed_cb_g_object_notify));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_combobox_changed_cb", G_CALLBACK(_math_converter_to_combobox_changed_cb_g_object_notify));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_focus_cb", G_CALLBACK(_math_converter_from_entry_focus_cb_g_object_notify));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_focus_cb", G_CALLBACK(_math_converter_to_entry_focus_cb_g_object_notify));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_cb", G_CALLBACK(_math_converter_key_press_cb_gtk_event_controller_key_key_pressed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_click_cb", G_CALLBACK(_math_converter_from_entry_click_cb_gtk_gesture_click_pressed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_click_cb", G_CALLBACK(_math_converter_to_entry_click_cb_gtk_gesture_click_pressed));
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "mathconverter");
}

static void
math_converter_instance_init (MathConverter * self,
                              gpointer klass)
{
	GSimpleActionGroup* _tmp0_;
	self->priv = math_converter_get_instance_private (self);
	self->priv->from_combobox_changed = (gulong) 0;
	_tmp0_ = g_simple_action_group_new ();
	self->priv->action_group = _tmp0_;
	self->priv->_outer_box_visible = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
math_converter_finalize (GObject * obj)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
	_g_object_unref0 (self->priv->_equation);
	_g_free0 (self->priv->category);
	_g_object_unref0 (self->priv->from_number);
	_g_object_unref0 (self->priv->to_number);
	_g_object_unref0 (self->priv->fixed_serializer);
	_g_object_unref0 (self->priv->action_group);
	G_OBJECT_CLASS (math_converter_parent_class)->finalize (obj);
}

static GType
math_converter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MathConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathConverter), 0, (GInstanceInitFunc) math_converter_instance_init, NULL };
	GType math_converter_type_id;
	math_converter_type_id = g_type_register_static (gtk_grid_get_type (), "MathConverter", &g_define_type_info, 0);
	MathConverter_private_offset = g_type_add_instance_private (math_converter_type_id, sizeof (MathConverterPrivate));
	return math_converter_type_id;
}

GType
math_converter_get_type (void)
{
	static volatile gsize math_converter_type_id__once = 0;
	if (g_once_init_enter (&math_converter_type_id__once)) {
		GType math_converter_type_id;
		math_converter_type_id = math_converter_get_type_once ();
		g_once_init_leave (&math_converter_type_id__once, math_converter_type_id);
	}
	return math_converter_type_id__once;
}

static void
_vala_math_converter_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
	switch (property_id) {
		case MATH_CONVERTER_EQUATION_PROPERTY:
		g_value_set_object (value, math_converter_get_equation (self));
		break;
		case MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY:
		g_value_set_boolean (value, math_converter_get_outer_box_visible (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_math_converter_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
	switch (property_id) {
		case MATH_CONVERTER_EQUATION_PROPERTY:
		math_converter_set_equation (self, g_value_get_object (value));
		break;
		case MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY:
		math_converter_set_outer_box_visible (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

